// Define the configuraton for the I/O
var DIGITAL_INPUTS_LOCATION = '/sys/class/gpio/gpio';
var DIGITAL_INPUTS_BASEGPIO = 448;// Default=448
var DIGITAL_INPUTS_POINTS = 48;// Default=48

// The following array holds, in memory, the current value (as 0 or 1 values)
var digitalInputsArray = [
    { "Address" : "0", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, //376
    { "Address" : "1", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "2", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "3", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },
    { "Address" : "4", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "5", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "6", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "7", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },

    { "Address" : "8", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "9", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "10", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "11", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },
    { "Address" : "12", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "13", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "14", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "15", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },

    { "Address" : "16", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "17", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "18", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "19", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },
    { "Address" : "20", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "21", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "22", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "23", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },

    { "Address" : "24", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, //352
    { "Address" : "25", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "26", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "27", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },
    { "Address" : "28", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "29", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "30", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "31", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },

    { "Address" : "32", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "33", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "34", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "35", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },
    { "Address" : "36", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "37", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "38", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "39", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },

    { "Address" : "40", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "41", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "42", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "43", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },
    { "Address" : "44", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "45", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "46", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "47", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer":0,"Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }
];

// Requires
var fs = require('fs');
var moment = require('moment');

// Initialize the digital inputs upon system start
//      - Checks if database table exists, if not creates the table and fills it with default data for each point
//      - Else reads from the database and updates digitalInputsArray
exports.InitializeDigitalInputs = function (db, io, logger,callback) {
    // Try getting the DigitalInputs table
    db.get("SELECT name FROM sqlite_master WHERE type='table' AND name='DigitalInputs'", function (err, rows) {
        if (err !== null) {
            logger.error('Digital Inputs - Initialize Error (Check)=' + JSON.stringify(err));
        }
        else if (rows === undefined) {
            // We read nothing, so let's create the table ...
            logger.info("Digital Inputs - Initialize by creating database table ...");
            db.exec("CREATE TABLE if not exists DigitalInputs (Address INTEGER, Name TEXT, Value TEXT, Enabled TEXT, SendEvents TEXT, Polarity TEXT, HoldTime INTEGER, TimeChanged TEXT )", function (err) {
                if (err !== null) {
                    logger.error('Digital Inputs - Initialize Error (Create)=' + JSON.stringify(err));
                }
                else {
                    var timeChanged = moment();// Record the create time as the last time the I/O point value was changed
                    
                    // Created the table, now add data ...
                    db.run("BEGIN")
                    for (var i = 0; i < DIGITAL_INPUTS_POINTS; i++) {
                        // Initialize the array
                        UpdateDigitalInputConfiguration(i, "Digital Input " + (i+1), 0, "TRUE", "TRUE", "Normally Open", 0, timeChanged, io, logger);
                        digitalInputsArray[i].TempValue = 0;
                        digitalInputsArray[i].ValueChanged = false;
                        digitalInputsArray[i].HoldTimer = timeChanged;
                        
                        // Initialize the database
                        insertStatement = i + ", 'Digital Input " + (i+1) + "', '0', 'TRUE', 'TRUE', 'Normally Open', 0, '" + timeChanged + "'";
                        db.run("INSERT INTO DigitalInputs (Address, Name, Value, Enabled, SendEvents, Polarity, HoldTime, TimeChanged) VALUES (" + insertStatement + ")", function (err) {
                            if (err !== null) {
                                logger.error('Digital Inputs - Initialize Error (Insert)=' + JSON.stringify(err));
                            }
                        });
                    }
                    db.run("COMMIT");
                    
                    // Digital Inputs table created
                    if (typeof callback == "function") {
                        logger.info('Digital Inputs - Initialized new database table');
                        callback();
                    }
                }
            });
        }
        else {
            // Read from the database and populate the digitalInputsArray
            logger.info("Digital Inputs - Initialize by reading database ...");
            db.each("SELECT rowid as id, Address, Name, Value, Enabled, SendEvents, Polarity, HoldTime, TimeChanged FROM DigitalInputs ORDER BY Address", function (err, row) {
                if (err !== null) {
                    logger.error('Digital Inputs - Initialize Error (Select)=' + JSON.stringify(err));
                }
                else {
                    UpdateDigitalInputConfiguration(row.Address, row.Name, row.Value, row.Enabled, row.SendEvents, row.Polarity, row.HoldTime, row.TimeChanged, io, logger);
                    logger.trace("Digital Inputs - [Value INITIAL from dB] Digital Input[" + row.Address + "] '" + row.Name + "' Value=" + row.Value);
                    digitalInputsArray[row.Address].TempValue = row.Value;
                    digitalInputsArray[row.Address].HoldTimer = row.TimeChanged;
                }
            }, function () { 
                // Digital Inputs read from table
                if (typeof callback == "function") {
                    logger.info('Digital Inputs - Initialized from existing database table');
                    callback();
                }
            });            
        }
    });
}

// Adjust the digitalInputsArray
module.exports.UpdateDigitalInputConfiguration = UpdateDigitalInputConfiguration;
function UpdateDigitalInputConfiguration(Address, Name, Value, Enabled, SendEvents, Polarity, HoldTime, TimeChanged, io, logger) {
    digitalInputsArray[Address].Name = Name;
    digitalInputsArray[Address].Value = Value;
    digitalInputsArray[Address].Enabled = Enabled;
    digitalInputsArray[Address].SendEvents = SendEvents;
    digitalInputsArray[Address].Polarity = Polarity;
    digitalInputsArray[Address].HoldTime = HoldTime;
    digitalInputsArray[Address].TimeChanged = TimeChanged;
    sendValueDigitalInputs(io, logger);// Update the Digital Inputs configuration
}

// Intervalled processing of digital inputs
var processCounter = 0;
var processTotalTime = 0;
exports.ProcessDigitalInputs = function (db, logger, io, netSnmp, ledManager,callback) {
    timeStart = moment();

    var index;// This is an index to digital I/O point - accounts for first 24 bits being at a higher location that the second 24 bits
    var fileIndex;// This is an index to the GPIO location - it's the index + the GPIO offset
    var offset = 0;
    var timeChanged = moment();
    for (index = 0; index < DIGITAL_INPUTS_POINTS; index++) {
        // This f'ed up logic is that first 24 I/O points are higher than the next 24 I/O points
        if (offset < 24) {
            fileIndex = DIGITAL_INPUTS_BASEGPIO + index + 24;
        }
        else {
            fileIndex = DIGITAL_INPUTS_BASEGPIO + index - 24;
        }
        offset++;
        
        // Only read value if the I/O point is enabled
        if (digitalInputsArray[index].Enabled === "TRUE") {
            try {
                data = fs.readFileSync(DIGITAL_INPUTS_LOCATION + fileIndex + "/value");
                readValue = String(data).replace(/(\r\n|\n|\r)/gm, "");
                
                // Normally Closed vs Normally Open
                if (digitalInputsArray[index].Polarity == "Normally Open") {
                    if (readValue === "1") {
                        readValue = "0";
                    } else {
                        readValue = "1";
                    }
                }

                // Check to see if value has changed, record the change in the TempValue
                if (digitalInputsArray[index].TempValue != readValue) {
                    digitalInputsArray[index].TempValue = readValue;
                    digitalInputsArray[index].HoldTimer = timeChanged;
                    digitalInputsArray[index].ValueChanged = true;
                    //logger.info("ProcessDigitalInputs: Address=" + index + " changed - Value='" + digitalInputsArray[index].Value + "' TempValue='" + digitalInputsArray[index].TempValue + "' readValue='" + readValue + "' ValueChanged="+ digitalInputsArray[index].ValueChanged);
                }
                
                // Now check if it's been passed the hold time, if so, affect change
                if (digitalInputsArray[index].ValueChanged == true) {
                    //logger.info("ProcessDigitalInputs: Index="+index+" TempValue='" + digitalInputsArray[index].TempValue + "' Value='" + digitalInputsArray[index].Value + "'");
                    //logger.info("ProcessDigitalInputs: Index="+index+" HoldTimer='" + digitalInputsArray[index].HoldTimer + "' timeChanged='" + timeChanged + "'")
                    //logger.info("ProcessDigitalInputs: Index="+index+" Timer difference='" + (timeChanged - digitalInputsArray[index].HoldTimer) / 1000 + "' HoldTime='" + digitalInputsArray[index].HoldTime + "'");
                    
                    // Send instanteous changes to UI
                    //logger.info("ProcessDigitalInputs: Stringified digitalInputsArray[index]=" + JSON.stringify(digitalInputsArray[index]));
                    tempDigitalInputPoint = JSON.parse(JSON.stringify(digitalInputsArray[index]));
                    tempDigitalInputPoint.Value = digitalInputsArray[index].TempValue;
                    sendValueDigitalInput("DigitalInput", tempDigitalInputPoint, io, logger);
                    //logger.info("ProcessDigitalInputs: Address=" + index + " changed - Value='" + tempDigitalInputPoint.Value + "' TempValue='" + tempDigitalInputPoint.TempValue + "'");

                    // Send SNMP if (a) The hold time has been met and (b) we are at a value different than when we started the hold time
                    if ((digitalInputsArray[index].Value != digitalInputsArray[index].TempValue) && 
                        ((timeChanged - digitalInputsArray[index].HoldTimer) / 1000 >= digitalInputsArray[index].HoldTime)) {
                        // Satisfied the hold time, so update the actual value
                        //logger.info("ProcessDigitalInputs: Met Hold Time requirements - Index="+index+" Updated Value='" + digitalInputsArray[index].Value + "'");
                        digitalInputsArray[index].Value = digitalInputsArray[index].TempValue;
                        digitalInputsArray[index].TimeChanged = timeChanged;
                        digitalInputsArray[index].HoldTimer = timeChanged;
                        digitalInputsArray[index].ValueChanged = false;
                        sendSocketAndSnmp(digitalInputsArray[index], db, io, logger, netSnmp)

                        db.run("UPDATE DigitalInputs SET Value='" + digitalInputsArray[index].Value 
                            + "', TimeChanged='" + digitalInputsArray[index].TimeChanged 
                            + "' WHERE Address = '" + index + "'", 
                            function (){
                        });                    
                    }
                }
                //logger.info("DigitalInput[" + index + "]=" + readValue + " (Enabled)")
            }
       		catch (error) {
                logger.error('Digital Inputs - Process Error (Read)=' + JSON.stringify(error));

                if (typeof callback == "function") {
                    callback(digitalInputsArray);
                }
            }
        }
        else {
            //logger.info("DigitalInput[" + index + "]=" + digitaInputsArray[index].Value + " (Disabled)")
        }
    }
    //if (processCounter === 500) {
    //    logger.info("ProcessDigitalInputs: Average process time = " + (processTotalTime / processCounter).toFixed(2) + "msec");
    //    processCounter = 0;
    //    processTotalTime = 0;
    //}
    //processCounter++;
    //processTotalTime += (Date.now() - timeStart);

    if (typeof callback == "function") {
        callback(digitalInputsArray);
    }
}

// Initialize the snmpHostSessionsArray used for send SNMP messages
var SnmpHostSessionsArray = [];// Instance array for list of SNMP host sessions
exports.SetSnmpHostSessionsArray = function (snmpHostSessions, logger,callback) {
    SnmpHostSessionsArray = snmpHostSessions.slice(0);// Copy array
    logger.trace("Digital Inputs - Initialized SNMP Host Sessions");

    if (typeof callback == "function") {
        callback();
    }
}

// Send updates to clients
function sendSocketAndSnmp(digitalInput, db, io, logger, netSnmp) {
    logger.info("Digital Inputs - [Value UPDATED] Digital Input["+digitalInput.Address+"] '"+digitalInput.Name+"' Value=" + digitalInput.Value);
    logger.trace("Digital Inputs - [Value UPDATED] Digital Input[" + digitalInput.Address + "] ="+ JSON.stringify(digitalInput));

    // SOCKET.IO: Send changed value to all attached clients
    sendValueDigitalInput("DigitalInput", digitalInput, io, logger);
    
    // SNMP: Send SNMP Trap/Notification if threshold(s) crossed
    sendSNMP(digitalInput, io, logger,netSnmp);
  }

function sendValueDigitalInput(dataType, data,io,logger) {
    io.sockets.emit(dataType, data);
}

function sendValueDigitalInputs(io, logger) {
    enabled = 0;
    for (i = 0; i < digitalInputsArray.length; i++) {
        if (digitalInputsArray[i].Enabled === "TRUE") enabled++;
    }
    io.sockets.emit("DigitalInputs", {"DigitalInputsTotal": digitalInputsArray.length, "DigitalInputsEnabled": enabled})
}

function sendSNMP(ioPoint, io, logger, netSnmp) {
    // SNMP definitions - also refer to the TASC-SUMMIT.MIB file for detailed information
    if (ioPoint.Enabled == "FALSE") return;
    if (ioPoint.SendEvents == "FALSE") return;
    
    address = parseInt(ioPoint.Address) + 1;// To overcome concatenation
    logger.info("Digital Inputs - Sending SNMP Trap for Digital Input[" + address + "]");
    
    // Set up the SNMP trap    
    var trapOid = "1.3.6.1.4.1.11902.3.1.1000.1000.0." + (address-1+1000) ;
    var varbinds = [
        {
            // Timestamp
            oid: "1.3.6.1.4.1.11902.3.1." + (address) + ".0.1",
            type: netSnmp.ObjectType.OctetString,
            value: new Buffer(moment().toString())
        },
        {
            // Address
            oid: "1.3.6.1.4.1.11902.3.1." + (address) + ".0.2",
            type: netSnmp.ObjectType.Integer,
            value: parseInt(ioPoint.Address)+1
        },
        {
            // Name
            oid: "1.3.6.1.4.1.11902.3.1." + (address) + ".0.3",
            type: netSnmp.ObjectType.OctetString,
            value: new Buffer(ioPoint.Name)
        },
        {
            // Value ("ON" or "OFF")
            oid: "1.3.6.1.4.1.11902.3.1." + (address) + ".0.4",
            type: netSnmp.ObjectType.OctetString,
            value: new Buffer((ioPoint.Value === "1") ? "ON":"OFF")
        },
        {
            // Status (1=ON, 0=OFF)
            oid: "1.3.6.1.4.1.11902.3.1." + (address) + ".0.5",
            type: netSnmp.ObjectType.Integer,
            value: (ioPoint.Value === "1") ? 1:0
        },
        {
            // Polarity (1=Normally Closed, 0=Normally Open)
            oid: "1.3.6.1.4.1.11902.3.1." + (address) + ".0.6",
            type: netSnmp.ObjectType.Integer,
            value: (ioPoint.Polarity === "Normally Closed") ? 1: 0
        },
        {
            // Hold Time
            oid: "1.3.6.1.4.1.11902.3.1." + (address) + ".0.7",
            type: netSnmp.ObjectType.Integer,
            value: parseInt(ioPoint.HoldTime)
        },
    ];
    
    // Send the SNMP notification
    for (i = 0; i < SnmpHostSessionsArray.length; i++) {
        // Skip if this host is not enabled
        if (SnmpHostSessionsArray[i].Enabled === "FALSE") continue;

        // Send trap to host ...
        IPAddress = SnmpHostSessionsArray[i].Session.target;
        SnmpHostSessionsArray[i].Session.trap(trapOid, varbinds, function (error) {
            if (error)
                logger.error("Digital Inputs - Send SNMP Error=" + error);
            else
                logger.trace("Digital Inputs - Sending to SNMP Host @ "+IPAddress+" - Digital Input[" + varbinds[1].value + "] '" + varbinds[2].value + "' Value=" + varbinds[4].value);
        });
    }
}